/**
 * Copyright 2018-2019, Optimizely
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import * as React from 'react';
import { UserWrappedOptimizelySDK } from './createUserWrapper';
export interface WithOptimizelyProps {
    optimizely: UserWrappedOptimizelySDK | null;
    optimizelyReadyTimeout: number | undefined;
    isServerSide: boolean;
}
export declare function withOptimizely<P extends WithOptimizelyProps>(Component: React.ComponentType<P>): {
    new (props: Readonly<Pick<P, import("utility-types/dist/mapped-types").SetDifference<keyof P, "optimizely" | "optimizelyReadyTimeout" | "isServerSide">>>): {
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<P, import("utility-types/dist/mapped-types").SetDifference<keyof P, "optimizely" | "optimizelyReadyTimeout" | "isServerSide">>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<Pick<P, import("utility-types/dist/mapped-types").SetDifference<keyof P, "optimizely" | "optimizelyReadyTimeout" | "isServerSide">>>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
    new (props: Pick<P, import("utility-types/dist/mapped-types").SetDifference<keyof P, "optimizely" | "optimizelyReadyTimeout" | "isServerSide">>, context?: any): {
        render(): JSX.Element;
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<Pick<P, import("utility-types/dist/mapped-types").SetDifference<keyof P, "optimizely" | "optimizelyReadyTimeout" | "isServerSide">>>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callBack?: (() => void) | undefined): void;
        readonly props: Readonly<{
            children?: React.ReactNode;
        }> & Readonly<Pick<P, import("utility-types/dist/mapped-types").SetDifference<keyof P, "optimizely" | "optimizelyReadyTimeout" | "isServerSide">>>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
    };
    contextType?: React.Context<any> | undefined;
};
